;    convert.inc - conversionfunctions needed by sportdag.com
;    Copyright (C) 2002  Rik Snel  <snel@phys.uu.nl>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License version 2 as 
;    published by the Free Software Foundation. 
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Conv_BCD2AX: 
	push bx
	cmp byte [BCDAccum], 6
	ja .error
	xor bx, bx
	mov bl, [BCDAccum+4]	;LSB
	mov al, [BCDAccum+3]	
	cbw
	shl ax, 1		; bx = 2*ax + 8*ax + bx
	add bx, ax
	shl ax, 1
	shl ax, 1
	add bx, ax
	mov al, [BCDAccum+2]
	cbw
	shl ax, 1		; bx = 4*ax + 32*ax + 64*ax
	shl ax, 1
	add bx, ax
	shl ax, 1
	shl ax, 1
	shl ax, 1
	add bx, ax
	shl ax, 1
	add bx, ax
	mov al, [BCDAccum+1]
	cbw
	shl ax, 1		; bx = 8*ax + 32*ax + 64*ax + 128*ax +
	shl ax, 1		;      256*ax + 512*ax + bx
	shl ax, 1
	add bx, ax
	shl ax, 1
	shl ax, 1
	add bx, ax
	shl ax, 1
	add bx, ax
	shl ax, 1
	add bx, ax
	shl ax, 1
	add bx, ax
	shl ax, 1
	add bx, ax
	mov al, [BCDAccum]
	cbw
	shl ax, 1
	shl ax, 1
	shl ax, 1
	shl ax, 1
	add bx, ax
	shl ax, 1
	shl ax, 1
	shl ax, 1
	shl ax, 1
	add bx, ax
	shl ax, 1
	add bx, ax
	shl ax, 1
	add bx, ax
	shl ax, 1
	shl ax, 1
	shl ax, 1
	add bx, ax
	jc .error
	mov ax, bx
	pop bx
	clc
	ret
.error:
	pop bx
	stc
	ret

Conv_AX2BCD:
	push ax
	push bx
	push dx
	mov bx, 10
	xor dx, dx
	div bx
	mov [BCDAccum+4], dl
	cmp ax, 0
	je z4
	xor dx, dx
	div bx
	mov [BCDAccum+3], dl
	cmp ax, 0
	je z3
	xor dx, dx
	div bx
	mov [BCDAccum+2], dl
	cmp ax, 0
	je z2
	xor dx, dx
	div bx
	mov [BCDAccum+1], dl
	cmp ax, 0
	je z1
	xor dx, dx
	div bx
	mov [BCDAccum], dl
	pop dx
	pop bx
	pop ax
	ret
z4:
	mov [BCDAccum+3], al
z3:
	mov [BCDAccum+2], al
z2:
	mov [BCDAccum+1], al
z1:
	mov [BCDAccum], al
	pop dx
	pop bx
	pop ax
	ret

Clear_FTPBuffer:
	push ax
	xor ax, ax
	mov [FTPBuffer], ax
	mov [FTPBuffer+2], ax
	mov [FTPBuffer+4], ax
	mov [FTPBuffer+6], ax
	mov [FTPBuffer+8], ax
	pop ax
	ret

Clear_BCDAccum:
	push ax
	xor ax, ax
	mov [BCDAccum], ax
	mov [BCDAccum+2], ax
	mov [BCDAccum+4], al
	pop ax
	ret
	
Remove_Leading_ALs: 	;input: al is te removen teken, ah is aantal removed
	xor ah, ah
	jcxz .error	;legestring?->Error!
.remove:
	cmp [si], al	;cx is wat nog van de string over is
	jne .end
	inc si
	inc ah
	dec cx
	jnz .remove		;Legestring?->Klaar
.end:
	clc
 	ret
.error:
	stc
	ret

Remove_Trailing_ALs:	;input: al is te removen teken, ah is aantal removed
	xor ah, ah
	jcxz .error
	add si, cx
	dec si
.remove:
	cmp [si], al
	jne .end
	inc ah
	dec si
	dec cx
	jnz .remove
.end:
	sub si, cx
	inc si
	clc
	ret
.error:
	stc
	ret

Conv_Komma_Info:    ;In: si is cx term string, Out ch # voor, cl # na incl.
	jcxz .error
	push si
.check:
	cmp byte [si], ','
	je .end
	cmp byte [si], '.'
	je .end
	inc si
	inc ch
	dec cl
	jnz .check	
.end:
	pop si
	clc
	ret
.error:
	stc
	ret

Conv_String2FTPBuffer: 
	push bx
	push cx
	push si
	xor ax, ax
	mov bx, ax
	mov cx, ax
	mov cl, [si]
	inc si
	mov al, ' '
	call Remove_Leading_ALs
	jc .error3
	call Remove_Trailing_ALs
	jc .error3
	mov al, '0'		
	call Remove_Leading_ALs
	mov bh, ah
	call Conv_Komma_Info
	cmp cl,1
	jna .tru1
	xchg bl, ch
	add cl, bl
	call Remove_Trailing_ALs
	sub cl, bl
	mov ch, bl
	add bh, ah
.tru1:
	cmp cl, 1
	jne .tru2
	dec cl
.tru2:
	cmp ch, 5
	ja .error1
	cmp cl, 6
	ja .error1
	push cx
	push di
	add cl, ch
	xor ax, ax
	xchg al, ch
	call Clear_FTPBuffer
	jcxz .alt
	mov di, FTPBuffer
	add di, 5
	sub di, ax
	inc al
.fill_check:
	mov ah, [si]
	dec al
	jz .comma
	sub ah, 48
	cmp ah, 9
	ja .error2
	mov [di], ah
	inc di
.comma:	
	inc si
	loop .fill_check
.end:	
	pop di
	pop ax
	cmp al, 0
	je .tru
	dec al
.tru
	pop si
	pop cx
	pop bx	
	clc
	ret
.alt:
	cmp bh, 0
	jne .end
.error2:
	pop di
	pop ax
.error1:
	pop si
	pop cx
	pop bx
	stc
	ret
.error3:
	mov ah, 255
	pop si
	pop cx
	pop bx
	stc
	ret


Conv_FTPBuffer2AX:
	push cx
	push di
	push si
	cmp al, 5
	jne .tru1
	mov cx, 5
	mov si, FTPBuffer
	add si, 5
.check_loop:
	cmp byte [si], 0
	jne .error
	inc si
	loop .check_loop
.tru1:
	cmp ah, al
	ja .error
	xor ah, ah
	mov si, FTPBuffer
	add si, 5
	sub si, ax
	mov di, BCDAccum
	mov cx, 5
.transfer_loop:
	mov al, [si]
	mov [di], al
	inc si
	inc di
	loop .transfer_loop
	call Conv_BCD2AX
	jc .error
	cmp si, FTPBuffer + 10
	jae .tru
	cmp byte [si], 4
	jle .tru
	inc ax
	jz .error
.tru
	cmp ax, bx
	ja .error
	jne .tru3
	cmp byte [si], 5
	jae .tru3
	cmp byte [si], 0
	ja .error
.check_loop2:
	inc si
	cmp si, FTPBuffer+10
	je .tru3
	cmp byte [si], 0
	jne .error
	jmp .check_loop2
.tru3	
	pop si
	pop di
	pop cx
	clc
	ret
.error
	pop si
	pop di
	pop cx
	stc
	ret

Conv_BCD2String:
	push ax
	push bx
	push cx
	push di
	push si
	xor bx, bx
	mov ah, bl
	mov si, BCDAccum
	mov di, StringBuffer
	inc di
	mov cx, 5
.fill_loop:
	mov bl, [si]
	dec al
	cmp bl, 0
	je .zero
	mov ah, 1
.zero:
	add bl, 48
	cmp al, 0
	je .print_digit_comma
	cmp ah, 1
	je .print_digit
	inc si
	loop .fill_loop
	jmp .end
.print_digit_comma:
	mov ah, 1
	mov [di], bl
	inc di
	inc bh
	cmp cx, 1
	je .end
	mov bl, ','
	add bl, [Comma]
	mov [di], bl
	inc di
	inc bh
	inc si
	loop .fill_loop
	jmp .end	
.print_digit:
	mov [di], bl
	inc bh
	inc di
	inc si
	loop .fill_loop
.end:
	mov di, StringBuffer
	mov [di], bh	
	pop si
	pop di
	pop cx
	pop bx
	pop ax
	clc
	ret