;    debug.inc - debugging functions needed by sportdag.com
;    Copyright (C) 2002  Rik Snel  <snel@phys.uu.nl>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License version 2 as 
;    published by the Free Software Foundation. 
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

; Speciale verkorte macro-namen
%macro DW2S 2
    push ax
    push di
    mov ax, %1
    mov di, %2
    call HexWord2Screen
    pop di
    pop ax
%endmacro

%macro DW2S 3
    push ax
    push dx
    push di
    mov ax, %1
    mov dh, %2
    mov dl, %3
    call Textp_Calc_DI
    call HexWord2Screen
    pop di
    pop dx
    pop ax
%endmacro

%macro DB2S 2
    push ax
    push di
    mov al, %1
    mov di, %2
    call HexByte2Screen
    pop di
    pop ax
%endmacro

%macro DB2S 3
    push ax
    push dx
    push di
    mov al, %1
    mov dh, %2
    mov dl, %3
    call Textp_Calc_DI
    call HexByte2Screen
    pop di
    pop dx
    pop ax
%endmacro

%macro DA2S 1
    push di
    mov di, %1
    call MonitorBCDAccum
    pop di
%endmacro

%macro DA2S 2
    push dx
    push di
    mov dh, %1
    mov dl, %2
    call Textp_Calc_DI
    call MonitorBCDAccum
    pop di
    pop dx
%endmacro

HexWord2Screen: ; Uit ax to [es:di], no clipping at all! 
    xchg al, ah
    call HexByte2Screen
    xchg al, ah
    call HexByte2Screen
    ret

HexByte2Screen:    ; Uit al to [es:di], no clipping at all!
    push ax
    push ax
    shr al, 1
    shr al, 1
    shr al, 1
    shr al, 1
    add al, 48
    cmp al, 57
    jna no_letters1
    add al, 7
no_letters1:
    mov [es:di], al
    add di, 2
    pop ax
    and al, 00001111b
    add al, 48
    cmp al, 57
    jna no_letters2
    add al, 7
no_letters2:
    mov [es:di], al
    add di, 2
    pop ax
    ret

MonitorBCDAccum:    
	push ax
	mov al, [BCDAccum]
	call HexByte2Screen
	xor al, al
	Textm_Output_AL_DI
	mov al, [BCDAccum+1]
	call HexByte2Screen
	xor al, al
	Textm_Output_AL_DI
	mov al, [BCDAccum+2]
	call HexByte2Screen
	xor al, al
	Textm_Output_AL_DI
	mov al, [BCDAccum+3]
	call HexByte2Screen
	xor al, al
	Textm_Output_AL_DI
	mov al, [BCDAccum+4]
	call HexByte2Screen
	pop ax
	ret

MonitorFTPBuffer:
	push ax
	push bx
	push cx
	mov bx, FTPBuffer
	mov cx, 10
.disp_loop:
	mov al, [bx]
	call HexByte2Screen
	xor al, al
	Textm_Output_AL_DI
	inc bx
	loop .disp_loop
	pop cx
	pop bx
	pop ax
	ret