;    textctrl - text output functions to screen needed by sportdag.com
;    Copyright (C) 2002  Rik Snel  <snel@phys.uu.nl>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License version 2 as 
;    published by the Free Software Foundation. 
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;Cursor aan, all regs saved
%macro Textm_Cursor_On 0
	push ax
	push cx
	mov ah, 01
	mov ch, [CursorStart]
	mov cl, [CursorEnd]
	int 10h
	pop cx
	pop ax
%endmacro

;Cursor op DX
%macro Textm_Put_Cursor@DX 0
	push ax
	push bx
	mov ah, 2
	mov bh, 0
	int 10h
	pop bx
	pop ax
%endmacro

;Cursor uit, all regs saved
%macro Textm_Cursor_Off 0
	push ax
	push cx
	mov ah, 01
	mov cx, 02000h
	int 10h
	pop cx
	pop ax
%endmacro

;Calc DI, all regs but DI saved
%macro Textm_Calc_DI 0
	push dx
	push ax
	mov ax, 80
	mul dh
	xor dh, dh
	add ax, dx
	shl ax, 1
	mov di, ax      ; Bepaal di
	pop ax
	pop dx
%endmacro

;Vul een deel van met scherm met AL karakterkode, AH attribute, DI = even
; cx, di not saved.
%macro Textm_Fill_DI_AX 0   
	cld
	rep stosw
%endmacro    

%macro Textm_ClrScrn 0
	push ax
	push cx
	push di
	xor ax, ax
	mov di, ax
	mov ah, [Wit]
	mov cx, 2000
	Textm_Fill_DI_AX
	pop di
	pop cx
	pop ax
%endmacro

;Vul een deel van met scherm met AL karakterkode/attribute, DI = even/oneven
; cx, di not saved.
%macro Textm_Fill_DI_AL 0    
	jcxz %%ret
	cld
%%flush_loop:
	stosb
	inc di
	loop %%flush_loop
%%ret:
%endmacro

%macro Textm_Output_AL_DI 0
	mov [es:di], al
	add di, 2
%endmacro
   
%macro Textm_CXS_DI 0
	jcxz %%ret
	push si
	cld
%%flush_loop:    
	movsb
	inc di
	loop %%flush_loop
	pop si
%%ret:
%endmacro

%macro Textm_CXS_DH_DL 0
	push di
	Textm_Calc_DI
	Textm_CXS_DI
	pop di
%endmacro

%macro Textm_PS_DI 0
	push cx
	mov cl, [si]
	xor ch, ch
	inc si
	Textm_CXS_DI
	dec si
	pop cx
%endmacro

%macro Textm_PS_DH_DL 0
	push di
	Textm_Calc_DI
	Textm_PS_DI
	pop di
%endmacro

%macro Textm_Fill_LField_DI 0
	push cx
	push ax
	mov al, [si]
	mov ah, cl
	sub cl, al
	ja %%no_clip
	mov cl, ah
	inc si
	Textm_CXS_DI
	dec si
	pop ax
	jmp %%ret
%%no_clip:    
	xchg al, cl
	inc si
	Textm_CXS_DI
	dec si
	mov cl, al
	pop ax
	Textm_Fill_DI_AL
%%ret:
	pop cx
%endmacro    

%macro Textm_Fill_LField_DH_DL 0
	push di
	Textm_Calc_DI
	Textm_Fill_LField_DI
	pop di
%endmacro

%macro Textm_Fill_RField_DI 0
	push cx
	push ax
	mov ah, [si]
	sub cl, ah
	ja %%no_clip
	add cl, ah
	jmp %%ret
%%no_clip:    
	Textm_Fill_DI_AL
	mov cl, ah
%%ret:
	inc si
	Textm_CXS_DI
	dec si
	pop ax
	pop cx
%endmacro    

%macro Textm_Fill_RField_DH_DL 0
	push di
	Textm_Calc_DI
	Textm_Fill_RField_DI
	pop di
%endmacro

;Textp_Uncompress:
;	mov al, [si]
;	push di
;	mov di, 0
;	mov [es:di], al
;	add di, 4
;	mov [es:di], ch
;	add di, 2
;	mov [es:di], cl
;	pop di
;	push ax
;	mov ax, 0
;	int 16h
;	pop ax
;	cmp al, 32
;	jl Globaal_Symbool1
;	Textm_Output_DI_AL
;Globaal_Symbool2:
;	inc si
;	loop Textp_Uncompress
;	ret
;Globaal_Symbool1:
;	sub cx, ax
;	push cx
;	xor ch, ch
;	mov cl, al
;	mov al, 0
;	Textm_Fill_DI_AL
;	pop cx
;	jmp Globaal_Symbool2
	
; Initialize [TextSeg], [Wit], [Bright], [Inv], [CursorStart], [CursorEnd]
Textp_Init:
	push ax
	push bx
	push cx
	push di
	;push si
	mov ax, 03h                     
	int 10h
	
	mov ax, 040h
	mov es, ax
	mov ax, [es:63h]
	cmp ax, 03D4h
	je .tru1
	mov word [TextSeg], 0B000h
	mov [CRTAddr], ax
.tru1:
	
	mov ah, 3                       
	xor bh, bh
	int 10h
	mov [CursorStart], ch
	mov [CursorEnd], cl
	
	Textm_Cursor_Off
	mov es, [TextSeg]
	Textm_ClrScrn
	mov al, 196
	mov cx, 80
	mov di, 0
	Textm_Fill_DI_AL
	
	mov di, 8*2;
	mov cx, 32
	mov si, Sportdag
	Textm_CXS_DI
	mov si, Jaar
	mov cx, 4
	Textm_CXS_DI
	mov si, Jongens
	cmp byte [Geslacht], 'M'
	je .tru45
	mov si, Meisjes
.tru45
	mov cx, 10
	Textm_CXS_DI

	mov di, 160
	mov si, Legenda3
	mov cx, 80
	xor ah, ah
	Textm_CXS_DI
	;call Textp_Uncompress

	mov si, Legenda4
	mov cx, 80
	Textm_CXS_DI
	
	mov si, Select
	mov cx, 4
.fill1:
	push cx
	mov cx, 80
	Textm_CXS_DI
	pop cx
	loop .fill1
	
	;mov cx, 80
	;Textm_Fill_DI_AL
	mov si, Legenda5
	mov cx, 240
	Textm_CXS_DI
	mov si, Lijst
	mov cx, 14
.fill2:
	push cx
	mov cx, 80
	Textm_CXS_DI
	pop cx
	loop .fill2
	
	;pop si
	pop di
	pop cx
	pop bx
	pop ax
	ret

%macro Textm_Disp_Groep_DI 0
	push ax
	push cx
	mov ax, [si]
	call Conv_AX2BCD
	mov al, 5
	call Conv_BCD2String
	push si
	mov si, StringBuffer
	mov al, ' '
	mov cx, 2
	call Textp_Fill_RField_DI
	pop si
	pop cx
	pop ax
%endmacro
	
%macro Textm_Disp_Prestatie_DI 0
	push ax
	push cx
	mov ax, [si]
	cmp ax, 02710h
	jne .tru
	mov si, Leeg
	jmp .disp
.tru:
	call Conv_AX2BCD
	mov al, 3
	call Conv_BCD2String
	push si
	mov si, StringBuffer
.disp:
	mov al, ' '
	mov cx, 5
	call Textp_Fill_RField_DI
	pop si
	pop cx
	pop ax
%endmacro

%macro Textm_Disp_Punten_DI 0
	push ax
	push cx
	mov ax, [si]
	call Conv_AX2BCD
	mov al, 5
	call Conv_BCD2String
	push si
	mov si, StringBuffer
	mov al, ' '
	mov cx, 4
	call Textp_Fill_Rfield_DI
	pop si
	pop cx
	pop ax
%endmacro

%macro Textm_Disp_Naam_DI 0
	push cx
	mov cx, 26
	Textm_CXS_DI
	pop cx
%endmacro

%macro Textm_Disp_Geslacht_DI 0
	push ax
	mov al, [si]
	Textm_Output_AL_DI
	pop ax
%endmacro

%macro Textm_Disp_Leeftijd_DI 0
	push ax
	push cx
	push si
	xor ax, ax
	mov al, [si]
	mov si, ax
	shl ax, 1
	shl ax, 1
	add si, ax
	add si, GroepArray
	mov cx, 5
	Textm_CXS_DI
	pop si
	pop cx
	pop ax
%endmacro
	
Textp_MenuWrite_Line:
	push ax
	push bx
	push cx
	push dx
	push di
	push si
	mov bx, [Menu]
	mov ax, 22
	mov dl, [VELDENINFO]
	call Textp_Calc_DI
	inc si
	push dx
	mul si
	pop dx
	mov si, bx
	cmp dh, 2
	jne .tru
	sub di, 80*2
	mov cx, 20
	Textm_CXS_DI
	add di, 80*2 - 40
.tru
	add si, ax
	mov cx, 20
	Textm_CXS_DI
	pop si
	pop di
	pop dx
	pop cx
	pop bx
	pop ax
	ret

Textp_MenuClear_Line:
	push ax
	push cx
	push dx
	push di
	mov cx, 20
	mov al, ch
	mov dl, [VELDENINFO]
	call Textp_Calc_DI
	Textm_Fill_DI_AL
	pop di
	pop dx
	pop cx
	pop ax
	ret
	
Textp_SClear_Line:
	push ax
	push cx
	push dx
	push di
	xor al, al
	mov dl, 70
	Textm_Calc_DI
	mov cx, 2
	Textm_Fill_DI_AL
	add di, 2
	mov cx, 6
	Textm_Fill_DI_AL
	pop di
	pop dx
	pop cx
	pop ax
	ret
	
Textp_IWrite_Line:
	push ax
	push cx
	push dx
	push di
	push si
	inc si
	mov dl, 70
	Textm_Calc_DI
	mov ax, si
	mov dx, si
	mov si, StringBuffer
	cmp byte [Geslacht], 'M'
	je .tru3
	mov byte [StringBuffer], 2
	mov byte [StringBuffer+1], 0
	add al, 64
	mov byte [StringBuffer+2], al
	jmp .tru2
.tru3
	call Conv_AX2BCD
	mov al, 5
	call Conv_BCD2String
.tru2
	mov al, ' '
	mov cx, 2
	call Textp_Fill_RField_DI
	mov si, dx
	add di, 2
	mov ah, [Opgevuld-1+si]
	mov al, [Bestaand]
	and ah, 2
	jne .tru
	mov al, [NietBestaand]
	mov cx, 6
	Textm_Fill_DI_AL
	jmp .exit
.tru
	mov cx, 1
	Textm_Fill_DI_AL
 	pop si
	push si
	push bx
	mov bx, Leeftijden
	add si, bx
	Textm_Disp_Leeftijd_DI
	pop bx	
.exit
	pop si
	pop di
	pop dx
	pop cx
	pop ax
	ret

Textp_SWrite_Line:  ;si is het refgroepnummer-1, dh is de regel
	push ax
	push cx
	push dx
	push di
	push si
	mov dl, 70
	Textm_Calc_DI
	call DBp_Groep_AL_SI
	mov dx, si
	mov si, StringBuffer
	cmp byte [Geslacht], 'M'
	je .tru3
	mov byte [StringBuffer], 2
	mov byte [StringBuffer+1], 0
	add al, 64
	mov byte [StringBuffer+2], al
     	jmp .tru2
.tru3
	call Conv_AX2BCD
	mov al, 5
	call Conv_BCD2String
.tru2
	mov al, ' '
	mov cx, 2
	call Textp_Fill_RField_DI
	mov si, dx
	add di, 2
	mov ah, [si]
	mov cx, 6
.puntsterloop:
	mov al, [Ingevuld]
	shl ah, 1
	jc .tru
	mov al, [NietIngevuld]
.tru:
	Textm_Output_AL_DI
	loop .puntsterloop
	pop si
	pop di
	pop dx
	pop cx
	pop ax
	ret
		
Textp_FacClear_Line: ;(lijn in dh)
	push ax
	push cx
	push dx
	push di
	xor al, al
	mov dl, 30
	Textm_Calc_DI
	mov cx, 12
	Textm_Fill_DI_AL
	add di, 2
	mov cx, 1
	Textm_Fill_DI_AL
	add di, 2
	mov cx, 4
.clear_loop:
	push cx
	mov cx, 5
	Textm_Fill_DI_AL
	add di, 2
	pop cx
	loop .clear_loop
	pop di
	pop dx
	pop cx
	pop ax
	ret

	
Textp_FacWrite_Line:
	push ax
	push bx
	push cx
	push dx
	push di
	push si
	xor bx, bx
	mov dl, 43
	call Textp_Calc_DI
	shr si, 1
	shr si, 1
	mov al, 'M'
	shr si, 1
	jnc .tru2
	mov al, 'V'
.tru2
	Textm_Output_AL_DI
	add di, 2
	pop si
	push si
	shr si, 1
	adc bh, 0
	shr si, 1
	jnc .tru
	add bh, 2
.tru
	shr si, 1
	push si
	mov si, StringBuffer
	mov [si], bh
	Textm_Disp_Leeftijd_DI
	pop si
	mov dl, 30
	call Textp_Calc_DI
	shl si, 1
	shl si, 1
	mov bx, si
	shl si, 1
	add bx, si
	mov si, OnderArray
	add si, bx
	mov cx, 12
	Textm_CXS_DI
	pop si
	push si
	mov bx, si
	shl si, 1
	add bx, si
	shl bx, 1
	add bx, Factors
	mov dl, 51
	call Textp_Calc_DI
	mov cx, 3
.getallen_loop:
	push cx
	mov ax, [bx]
	cmp ax, 02710h
	jne .tru1
	mov si, Leeg
	jmp .disp1
.tru1:  
	call Conv_AX2BCD
	mov al, 3
	call Conv_BCD2String
	mov si, StringBuffer
.disp1: 
	mov al, ' '
	mov cx, 5
	call Textp_Fill_RField_DI   
	add bx, 2
	add di, 2
	pop cx
	loop .getallen_loop
	pop si
	pop di
	pop dx
	pop cx
	pop bx
	pop ax
	ret
		
Textp_Make_String_2Data: ; [bx] wijst naar 2bit data, cl is plaats vd komma
	mov ax, [bx]	; ax, cx,  wordt troep, si wijst naar string
	cmp ax, 02710h
	jne .tru1
	mov si, Leeg
	ret
 .tru1
	call Conv_AX2BCD
	mov al, cl
	call Conv_BCD2String
	mov si, StringBuffer
	ret

Textp_Write_Line:   ;si is de lijn in het x-bestand, dh is de regel
	push ax
	push bx
	push cx
	push dx
	push di
	push si
	xor dl, dl
	Textm_Calc_DI
	add di, 2
	call Si_Beg_Record
;	mov al, [si]
;	xor ah, ah
;	mov bx, si
;	mov si, StringBuffer
;	cmp byte [Geslacht], 'M'
;	je .tru3
;	mov byte [StringBuffer], 2
;	mov byte [StringBuffer+1], 0
;	add al, 64
;	mov byte [StringBuffer+2], al
;    	jmp .tru2
;.tru3
;	
;	call Conv_AX2BCD
;	mov al, 5
;	call Conv_BCD2String
;.tru2
;	mov al, ' '
;	mov cx, 2
;	call Textp_Fill_RField_DI
;	mov si, bx
	add si, 1
;	add di, 2
	mov cx, 26
	Textm_CXS_DI    
	add si, 26
;	add di, 2
;	mov al, [si]
;	Textm_Output_AL_DI
	inc si
;	add di, 2
	mov bx, si
;	xor ax, ax
;	mov al, [bx]
;	mov si, ax
;	shl ax, 1
;	shl ax, 1
;	add si, ax
;	add si, GroepArray
;	mov cx, 5
;	Textm_CXS_DI
	inc bx
	mov cx, 6
.prestatieloop
	push cx
	add di, 2
	mov cl, 3
	call Textp_Make_String_2Data
	mov al, ' '
	mov cx, 5
	call Textp_Fill_RField_DI   
	add bx, 2
	pop cx
	loop .prestatieloop
	add di, 2
	mov cl, 5
	call Textp_Make_String_2Data
	mov al, ' '
	mov cx, 4
	call Textp_Fill_RField_DI
	pop si
	pop di
	pop dx
	pop cx
	pop bx
	pop ax
	ret
	
Textp_PS_DH_DL:    
	Textm_PS_DH_DL
	ret

Textp_Fill_LField_DH_DL:
	Textm_Fill_LField_DH_DL
	ret

Textp_Fill_LField_DI:
	Textm_Fill_LField_DI 
	ret

Textp_CXS_DH_DL:
	Textm_CXS_DH_DL
	ret

Textp_Fill_RField_DH_DL:
	Textm_Fill_RField_DH_DL
	ret

Textp_Fill_RField_DI:
	Textm_Fill_RField_DI 
	ret

Textp_Calc_DI:
	Textm_Calc_DI
	ret

Textp_Clear_Text_Line:
	push ax
	push cx
	push di
	xor ax, ax
	mov al, 160
	mul dh
	mov di, ax  
	
;	add di, 2
	mov al, 0
;	Textm_Output_AL_DI
;	Textm_Output_AL_DI
	add di, 2
	mov cx, 26
.name_loop:
	Textm_Output_AL_DI
	loop .name_loop
	add di, 2
;	Textm_Output_AL_DI
;	add di, 2
;	mov cx, 5
;.leeftijd_loop:
;	Textm_Output_AL_DI
;	loop .leeftijd_loop
;	add di, 2
	mov cx, 6
.prestaties_loop:
	push cx
	mov cx, 5
.p_loop:
	Textm_Output_AL_DI
	loop .p_loop
	add di, 2
	pop cx
	loop .prestaties_loop
	mov cx, 4
.punten_loop:
	Textm_Output_AL_DI
	loop .punten_loop
	pop di
	pop cx
	pop ax
	ret

Textp_Set_Active:
	push ax
	mov al, [Bright]
	mov ah, [Wit]
	call Textp_Set_Attributes
	pop ax
	ret

Textp_Set_Unactive:
	push ax
	mov al, [Wit]
	mov ah, [Wit]
	call Textp_Set_Attributes
	pop ax
	ret
	 
Textp_Set_Attributes:
	push cx
	push dx
	push di
	push si
	mov cl, [AANTALVELDEN]
	mov dh, [MINLINE]
	xor dl, dl
.line_loop:
	lea si, [VELDENINFO]
	xor ch, ch
.attr_loop:
	mov dl, [si]
	cmp ch, [HORMIN]
	jb .attrwit
	cmp ch, [HORMAX]
	ja .attrwit
	push cx
	xor ch, ch
	mov cl, [si+1]
	Textm_Calc_DI
	inc di
	Textm_Fill_DI_AL
.set_at_door:	
	pop cx
	add si, 7
	inc ch
	cmp ch, cl
	jb .attr_loop
	inc dh
	cmp dh, [MAXLINE]
	jna .line_loop
	pop si
	pop di
	pop dx
	pop cx
	ret
.attrwit:
	push cx
	xor ch, ch
	mov cl, [si+1]
	Textm_Calc_DI
	inc di
	xchg al, ah
	Textm_Fill_DI_AL
	xchg al, ah
	jmp .set_at_door

Textp_InvAccToHorpos: ;dh is rij  dl wordt op de juiste kolom gezet
	push bx
	mov bl, [Bright]
	call Textp_FInvAccToHorpos
	pop bx
	ret

Textp_SemiInvAccToHorpos: ;dh is rij  dl wordt op de juiste kolom gezet
	push bx
	mov bl, [Wit]
	call Textp_FInvAccToHorpos
	pop bx
	ret

Textp_FInvAccToHorpos: ;dh is rij  dl wordt op de juiste kolom gezet
	push ax
	push cx
	push di
	push si
	lea si, [VELDENINFO]
	mov ch, [HORMIN]
	xor cl, cl
.skip_loop:
	cmp ch, cl
	je .exit_skip_loop
	add si, 7
	inc cl
	jmp .skip_loop
.exit_skip_loop:
	mov ah, cl
	mov cl, [HORMAX]
	sub cl, ch
.veld_loop:
	mov dl, [si]
	Textm_Calc_DI
	inc di
	mov al, bl
	cmp ah, [HORPOS]
	jne .tru
	mov al, [Inv]
	mov ch, dl
.tru
	push cx
	mov cl, [si+1]
	xor ch, ch
	Textm_Fill_DI_AL
	pop cx
	inc ah
	add si, 7
	cmp ah, [HORMAX]
	jna .veld_loop
	mov dl, ch
	pop si
	pop di
	pop cx
	pop ax
	ret

Textp_Clear_Attr:
	push ax
	push cx
	push dx
	push di
	push si
	mov ah, [HORPOS]
	mov al, ah
	shl ah, 1
	add al, ah
	shl ah, 1
	add al, ah
	xor ah, ah
	mov ch, ah
	lea si, [VELDENINFO]
	add si, ax
	mov al, [Bright]
	mov dl, [si]
	mov cl, [si+1]
	Textm_Calc_DI
	inc di
	Textm_Fill_DI_AL
	pop si
	pop di
	pop dx
	pop cx
	pop ax
	ret
			 