;    toetsctl.inc - text input functions needed by sportdag.com
;    Copyright (C) 2002  Rik Snel  <snel@phys.uu.nl>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License version 2 as 
;    published by the Free Software Foundation. 
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%macro Toetsm_Wacht 0
	push ax
	Toetsm_Input
	pop ax
%endmacro

%macro Toetsm_Input 0
	mov ax, 0
	int 16h
%endmacro

%macro Toetsm_Poll 0
%%over:    
	mov ax, 256
	int 16h
	jz %%over
%endmacro

%macro Toetsm_Clear_Buffer 0
	push ax
%%over:
	mov ax, 256
	int 16h
	jz %%exit
	mov ax, 0
	int 16h
	jmp %%over
%%exit:
	pop ax
%endmacro

Toetsp_Clear_Buffer:
	Toetsm_Clear_Buffer
	ret


Toetsp_Input_String_DX:  ; Alleen op EEN regel
	push ax
	push bx
	push di
	push si
	Textm_Calc_DI
	xor ax, ax
	xor bx, bx
	mov si, StringBuffer
	mov bl, [si]     ;Hoelang is de string al
	call Textp_Fill_LField_DI
	sub di, cx
	sub di, cx
	add di, bx
	add di, bx
	inc si
	push bx
	push cx
	sub cx, bx
	jcxz .tru
.clear_loop:
	mov byte [si+bx], 020h
	inc bx
	loop .clear_loop
.tru:
	pop cx
	pop bx
	Textm_Cursor_On
	add dl, bl
next_string_input:
	Textm_Put_Cursor@DX
	Toetsm_Poll
	call Toetsp_Ck_Extern_Toets
	jc .end
	cmp ax, 011Bh
	je .error
	cmp ax, 0E08h
	je .backspace
	cmp al, 32
	jb next_string_input
	cmp al, 127
	ja next_string_input
	cmp cl, bl
	je next_string_input
	mov [si+bx], al
	mov [es:di], al
	add di, 2
	inc bl
	inc dl
	jmp next_string_input
.backspace
	cmp bl, 0
	je next_string_input
	dec bl
	dec dl
	sub di, 2
;	mov byte [si+bx], 20
	mov byte [si+bx], ' '
	mov byte [es:di], 0
	jmp next_string_input
.end
	Textm_Cursor_Off
	dec si
	mov [si], bl
	sub dl, [si]
	clc
.exit	
	pop si
	pop di
	pop bx
	pop ax
	ret
.error:
	cmp word [MovesDown], 1
	jne .tru
	mov word [MovesDown], 2
.tru
	Textm_Cursor_Off
	dec si
	mov [si], bl
	sub dl, [si]
	stc
	jmp .exit
	
Toetsp_Ck_Extern_Toets:
	cmp ax, 01C0Dh   ; enter
	je .enter
	cmp ax, 04800h   ; up
	je .no_remove
	cmp ax, 05000h   ; dn
	je .no_remove
	cmp ax, 04B00h   ; le
	je .no_remove
	cmp ax, 04D00h   ; ri
	je .no_remove
	cmp ax, 04900h   ; pgup
	je .no_remove
	cmp ax, 05100h   ; pgdn
	je .no_remove
	cmp ax, 0F09h    ; tab
	je .no_remove
	cmp ax, 0F00h    ; shtab
	je .no_remove
	cmp ax, 04700h	 ; home
	je .no_remove
	cmp ax, 04F00h	 ; end
	je .no_remove
	Toetsm_Input
	clc
	ret
.enter
	Toetsm_Input
.no_remove
	stc
	ret              ; Let another part of the program deal with them
